"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const graphql_1 = require("graphql");
exports.DateType = new graphql_1.GraphQLScalarType({
    name: 'Date',
    serialize: date => {
        if (Number.isNaN(date.getTime())) {
            throw new Error('Invalid response date');
        }
        return date.toJSON();
    },
    parseValue: val => {
        return parse(val);
    },
    parseLiteral(ast) {
        if (ast.kind === graphql_1.Kind.STRING) {
            return parse(ast.value);
        }
        return null;
    },
});
function parse(val) {
    const date = new Date(val);
    if (val.length !== 24 || Number.isNaN(date.getTime())) {
        throw new graphql_1.GraphQLError('Incorrect Date: ' + val);
    }
    return date;
}
